library m_entity;

import 'package:sunny_sdk_core/model_exports.dart';
import 'package:sunny_service_stubs/models/m_entity/m_entity.dart';
export 'package:sunny_service_stubs/models/m_entity/m_entity.dart';

import 'model/embedded_property.dart';
import 'model/entity_list_property.dart';
import 'model/list_property.dart';
import 'model/lookup_result.dart';
import 'model/lookup_results.dart';
import 'model/m_entity_definition.dart';
import 'model/m_module_definition.dart';
import 'model/m_operation_definition.dart';
import 'model/m_operation_definition_list.dart';
import 'model/m_ref_schema_definition.dart';
import 'model/m_schema_definition.dart';
import 'model/m_schema_definition_list.dart';
import 'model/m_schema_property.dart';
import 'model/ref_property.dart';
import 'model/string_select_property.dart';

export 'model/embedded_property.dart';
export 'model/entity_list_property.dart';
export 'model/list_property.dart';
export 'model/lookup_result.dart';
export 'model/lookup_results.dart';
export 'model/m_entity_definition.dart';
export 'model/m_module_definition.dart';
export 'model/m_operation_definition.dart';
export 'model/m_operation_definition_list.dart';
export 'model/m_ref_schema_definition.dart';
export 'model/m_schema_definition.dart';
export 'model/m_schema_definition_list.dart';
export 'model/m_schema_property.dart';
export 'model/ref_property.dart';
export 'model/string_select_property.dart';

export 'ext/ext.dart';

const mthingModuleRef = MModuleRef.ofParts("mverse", "mthing", "0.0.1");

registerM_entityModels(
    MModelRegistry modelRegistry, MEnumRegistry enumRegistry) {
  modelRegistry.register(EmbeddedPropertyRef,
      (json) => EmbeddedProperty(json as Map<String, dynamic>));
  IEmbeddedProperty.of = EmbeddedProperty.of;
  IEmbeddedProperty.fromJson = EmbeddedProperty.fromJson;

  modelRegistry.register(EntityListPropertyRef,
      (json) => EntityListProperty(json as Map<String, dynamic>));
  IEntityListProperty.of = EntityListProperty.of;
  IEntityListProperty.fromJson = EntityListProperty.fromJson;

  modelRegistry.register(
      ListPropertyRef, (json) => ListProperty(json as Map<String, dynamic>));
  IListProperty.of = ListProperty.of;
  IListProperty.fromJson = ListProperty.fromJson;

  modelRegistry.register(
      LookupResultRef, (json) => LookupResult(json as Map<String, dynamic>));
  ILookupResult.of = LookupResult.of;
  ILookupResult.fromJson = LookupResult.fromJson;

  modelRegistry.register(
      LookupResultsRef, (json) => LookupResults(json as Map<String, dynamic>));
  ILookupResults.of = LookupResults.of;
  ILookupResults.fromJson = LookupResults.fromJson;

  modelRegistry.register(MEntityDefinitionRef,
      (json) => MEntityDefinition(json as Map<String, dynamic>));
  IMEntityDefinition.of = MEntityDefinition.of;
  IMEntityDefinition.fromJson = MEntityDefinition.fromJson;

  modelRegistry.register(MModuleDefinitionRef,
      (json) => MModuleDefinition(json as Map<String, dynamic>));
  IMModuleDefinition.of = MModuleDefinition.of;
  IMModuleDefinition.fromJson = MModuleDefinition.fromJson;

  modelRegistry.register(MOperationDefinitionRef,
      (json) => MOperationDefinition(json as Map<String, dynamic>));
  IMOperationDefinition.of = MOperationDefinition.of;
  IMOperationDefinition.fromJson = MOperationDefinition.fromJson;

  modelRegistry.register(MOperationDefinitionListRef,
      (json) => MOperationDefinitionList(json as Map<String, dynamic>));
  IMOperationDefinitionList.of = MOperationDefinitionList.of;
  IMOperationDefinitionList.fromJson = MOperationDefinitionList.fromJson;

  modelRegistry.register(MRefSchemaDefinitionRef,
      (json) => MRefSchemaDefinition(json as Map<String, dynamic>));
  IMRefSchemaDefinition.of = MRefSchemaDefinition.of;
  IMRefSchemaDefinition.fromJson = MRefSchemaDefinition.fromJson;

  modelRegistry.register(MSchemaDefinitionRef,
      (json) => MSchemaDefinition(json as Map<String, dynamic>));
  IMSchemaDefinition.of = MSchemaDefinition.of;
  IMSchemaDefinition.fromJson = MSchemaDefinition.fromJson;

  modelRegistry.register(MSchemaDefinitionListRef,
      (json) => MSchemaDefinitionList(json as Map<String, dynamic>));
  IMSchemaDefinitionList.of = MSchemaDefinitionList.of;
  IMSchemaDefinitionList.fromJson = MSchemaDefinitionList.fromJson;

  modelRegistry.register(MSchemaPropertyRef,
      (json) => MSchemaProperty(json as Map<String, dynamic>));
  IMSchemaProperty.of = MSchemaProperty.of;
  IMSchemaProperty.fromJson = MSchemaProperty.fromJson;

  modelRegistry.register(
      RefPropertyRef, (json) => RefProperty(json as Map<String, dynamic>));
  IRefProperty.of = RefProperty.of;
  IRefProperty.fromJson = RefProperty.fromJson;

  modelRegistry.register(StringSelectPropertyRef,
      (json) => StringSelectProperty(json as Map<String, dynamic>));
  IStringSelectProperty.of = StringSelectProperty.of;
  IStringSelectProperty.fromJson = StringSelectProperty.fromJson;
}
