library mentity.api;

import 'package:m_entity/m_entity.dart';
import 'package:sunny_sdk_core/model_exports.dart';
import 'package:sunny_service_stubs/models/m_entity/m_entity.dart';

mixin MSchemaPropertyMixin implements HasBaseCode, IMSchemaProperty {
  JsonPath? _jsonPath;

  JsonPath get jsonPath => _jsonPath ??= JsonPath.parsed(path!);

  bool isType(Definition definition) => definition.matches(this);

  bool get isNotRequired => isRequired != true;
}

mixin MEntityDefinitionMixin {}
mixin MSchemaDefinitionMixin implements IMSchemaDefinition {
  Map<JsonPath, IMSchemaProperty>? _propsByPath;

  Map<JsonPath, IMSchemaProperty> get propsByPath =>
      _propsByPath ??= mapOf(properties!, keyOf: (p) => p.jsonPath);

  IMSchemaProperty? prop(JsonPath path) => propsByPath[path];

  MSchemaRef? get self {
    final MSchemaDefinitionMixin self = this;
    if (self is IMEntityDefinition) {
      return (self as IMEntityDefinition).schemaRef;
    } else if (self is IMRefSchemaDefinition) {
      return (self as IMRefSchemaDefinition).schemaRef;
    } else {
      return null;
    }
  }

  IMEntityDefinition asEntitySchema() {
    if (this is! MEntityDefinition) return illegalState("Not an entity schema");
    return this as MEntityDefinition;
  }
}
